require 'LoggerWrapper'


# This class serves as data class for the bookmarks 
class Bookmark

  # The initialization method
  def initialize( title, level = 0, parent = nil )
    @level = level
    @title = title
    @parent = parent
    @children = []
    @number = -1
  end
  
  attr_accessor :level, :title, :parent, :children, :number
  
  # Conversion method into string (recursive)
  def to_s()
    str = '  ' * level + "Level: #{level}, Title: #{title}\n"
    if ( @children.length > 0 )
      str += '  ' * level + "Children: \n"
      @children.each() do | child |
        str += child.to_s()
      end
    end
    str
  end
  
  # Logging output (usable instead of to_s)
  def to_log()
    str = '  ' * level + "Level: #{level}, Title: #{title}"
    LoggerWrapper.instance().debug('Ruby') { str }
    if ( @children.length > 0 )
      str = '  ' * level + "Children: "
      LoggerWrapper.instance().debug('Ruby') { str }
      @children.each() do | child |
        child.to_log()
      end
    end
    str
  end
  
end
